<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:optim="http://www.ibm.com/optim/audit/v11.3.0.0"
	xmlns:optimreport="http://www.ibm.com/optim/report/v11.3.0.0"
	xmlns:optimcommon="http://www.ibm.com/optim/common/v11.3.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">

	<xsl:import href="CommonTemplates.xsl"/>
	<xsl:output method="html" indent="yes" version="4.0"
		doctype-public="-//W3C//DTD HTML 4.01//EN" doctype-system="http://www.w3.org/TR/html4/strict.dtd" />

	<!-- BEGIN relationships section -->
	<xsl:template match="optimreport:relationships">
		<xsl:call-template name="anchorSetup">
			<xsl:with-param name="name">table_access_strategy</xsl:with-param>
		</xsl:call-template>
		<!-- Relationship/Table Access Strategy Banner -->
		<xsl:call-template name="titleBar">
			<xsl:with-param name="name">Table Access Strategy</xsl:with-param>
			<xsl:with-param name="containerId">relations_container</xsl:with-param>
			<xsl:with-param name="containerClass">relations_container_class</xsl:with-param>
			<xsl:with-param name="anchor">table_access_strategy</xsl:with-param>
			<xsl:with-param name="closeByDefault">true</xsl:with-param>
		</xsl:call-template>
		
		<!-- Relationship/Table Access Strategy Contents -->
		<div id="relations_container" class="section_container relations_container_class" style="display:none;" inAllAction="true">
			<xsl:for-each select="optimreport:relationship">
				<!-- Create a table(collapsed) that can be expanded for each relationship in the XML -->
				<table class="table_access_headers">
					<tr>
						<td class="relation_header_name drop_down_hover" istitle="yes" onClick="toggleById('{generate-id(@relationshipName)}', event); swap('{generate-id(@relationshipName)}DetailsArrow','{generate-id(@relationshipName)}', event)">
							<xsl:call-template name="arrow">
								<xsl:with-param name="id" select="concat(generate-id(@relationshipName), 'DetailsArrow')"/>
								<xsl:with-param name="isExpand">false</xsl:with-param>
							</xsl:call-template>

							<xsl:text>&#160;&#160;&#160;</xsl:text>
							<xsl:value-of select="position()" />
							<xsl:text>&#160;&#160;&#160;&#160;&#160;</xsl:text>
							<b>
								<xsl:text>Relationship:&#160;&#160;&#160;</xsl:text>
							</b>
							<xsl:call-template name="stringCheck">
								<xsl:with-param name="value" select="@relationshipName"/>
							</xsl:call-template>
						</td>
					</tr>
				</table>
				<div id="{generate-id(@relationshipName)}" class="relation_content_table" style="display: none;" inAllAction="true">
					<table>
						<!-- Parent row -->
						<tr>
							<th>
								<xsl:text>Parent</xsl:text>
							</th>
							<td>
								<xsl:call-template name="stringCheck">
									<xsl:with-param name="value" select="@parentName"/>
								</xsl:call-template>
							</td>
							<th>
								<xsl:text>Key limit</xsl:text>
							</th>
							<td>
								<xsl:choose>
									<xsl:when test="optimreport:accessStrategy/optimreport:parentAccess/@keyLimit = -1">
										<xsl:text>Not Applicable</xsl:text>
									</xsl:when>
									<xsl:otherwise>
										<xsl:call-template name="numberFormat">
											<xsl:with-param name="number" select="optimreport:accessStrategy/optimreport:parentAccess/@keyLimit"/>
											<xsl:with-param name="digitsAfterPoint">0</xsl:with-param>
										</xsl:call-template>
									</xsl:otherwise>
								</xsl:choose>
							</td>
							<th>
								<xsl:text>Access strategy</xsl:text>
							</th>
							<td>
								<xsl:call-template name="stringCheck">
									<xsl:with-param name="value" select="optimreport:accessStrategy/optimreport:parentAccess/@accessStrategyType"/>
								</xsl:call-template>
							</td>
						</tr>
						<!-- Child row -->
						<tr>
							<th>
								<xsl:text>Child</xsl:text>
							</th>
							<td>
								<xsl:call-template name="stringCheck">
									<xsl:with-param name="value" select="@childName"/>
								</xsl:call-template>
							</td>
							<th>
								<xsl:text>Key limit</xsl:text>
							</th>
							<td>
								<xsl:choose>
									<xsl:when test="optimreport:accessStrategy/optimreport:childAccess/@keyLimit = -1">
										<xsl:text>Not Applicable</xsl:text>
									</xsl:when>
									<xsl:otherwise>
										<xsl:call-template name="numberFormat">
											<xsl:with-param name="number" select="optimreport:accessStrategy/optimreport:childAccess/@keyLimit"/>
											<xsl:with-param name="digitsAfterPoint">0</xsl:with-param>
										</xsl:call-template>
									</xsl:otherwise>
								</xsl:choose>
							</td>
							<th>
								<xsl:text>Access strategy</xsl:text>
							</th>
							<td>
								<xsl:call-template name="stringCheck">
									<xsl:with-param name="value" select="optimreport:accessStrategy/optimreport:childAccess/@accessStrategyType"/>
								</xsl:call-template>
							</td>
						</tr>
					</table>
				</div>
			</xsl:for-each>
		</div>
	</xsl:template>
	<!-- END relationships section -->

</xsl:stylesheet>

