<%@page pageEncoding="UTF-8"%>
<%@page import="java.util.ResourceBundle" %>
<%@page import="java.util.Locale" %>
<%@page import="java.util.HashMap" %>
<%@page import="java.text.MessageFormat" %>
<%@page import="java.util.MissingResourceException"%>

<%!
    
    HashMap <String,String> defaultLocales = null;

    private String getGoodLocale (String malformedLocale){
        if (defaultLocales == null){
            defaultLocales = new HashMap<String, String>();
            defaultLocales.put("fr-","fr-fr");
            defaultLocales.put("de-","de-de");
            defaultLocales.put("en-","en-us");
            defaultLocales.put("es-","es-es");
            defaultLocales.put("it-","it-it");
            defaultLocales.put("ja-","ja-jp");
            defaultLocales.put("ko-","ko-kr");
            defaultLocales.put("pt-","pt-br");
        }
        return defaultLocales.get(malformedLocale);
    }
%>
<%
    
    Locale currentLocale = request.getLocale();
   // System.out.println("Locale: " + currentLocale.toString());
    String localeStr = currentLocale.getLanguage()+"-" +currentLocale.getCountry().toLowerCase();
    if (localeStr.length()==3){
        localeStr = getGoodLocale(localeStr);
    }
    
    String lastLoginMessage = getMessage("lastLoginMessage", new Locale("en", "US"));
    lastLoginMessage = MessageFormat.format(lastLoginMessage, "${userID}", "${loginTime}");
    
    String lastLoginMessageNotAvailable = getMessage("lastLoginMessageNotAvailable", new Locale("en", "US"));
    lastLoginMessageNotAvailable = MessageFormat.format(lastLoginMessageNotAvailable, "${userID}");
    
    
   // System.out.println("LocaleString: " + localeStr);
   response.setHeader("X-Frame-Options", "SAMEORIGIN");
   if(isWasce(request.getRealPath("/"))){
       response.setHeader("SET-COOKIE", "JSESSIONID=" + request.getSession().getId() + "; HttpOnly; Secure");
   }
   response.setHeader("Cache-Control", "no-store");
   response.setHeader("Pragma", "no-store");
   
   String path = request.getRequestURL().toString();
%>
<%! 
private String getMessage(String key, Locale locale) {
    //Locale currentLocale = request.getLocale();
    ResourceBundle messages = ResourceBundle.getBundle("com.ibm.nex.dsi.ui.nls.resources", locale);
    String msg = key;
    try {
        msg = messages.getString(key);
    }catch (MissingResourceException e2) {
            String exMsg = "Login E2:Cannot get value for "+key+" in " + locale.toString() +".";
            new Exception(exMsg,e2).printStackTrace();
    }catch (Exception e) {
        String exMsg = "Login E:Cannot get value for "+key+" in " + locale.toString()+".";
        new Exception(exMsg,e).printStackTrace();
    }
    return msg;
}

/**
 * Flag to indicate if the webserver is wasce or not
 * @return boolean
 */
public boolean isWasce(String warfilePath) {
     if(warfilePath != null && !warfilePath.isEmpty()){
	     int optimIndex = -1;
	     if (warfilePath.indexOf('/') != -1) {
	         optimIndex = warfilePath.indexOf("/Optim/shared/WebSphere/");
	     } else if (warfilePath.indexOf('\\') != -1) {
	         optimIndex = warfilePath.indexOf("\\Optim\\shared\\WebSphere\\");
	     }
	
	     if (optimIndex != -1) {
	         return true;
	     }
     }
     return false;
 }
%>
<!DOCTYPE HTML>
<html>
<!-- 
* IBM Confidential
* OCO Source Materials
* 5724-U98, 5655-V48, 5724-U50, 5655-V46
* © Copyright IBM Corp. 2013
* The source code for this program is not published or other -
* wise divested of its trade secrets, irrespective of what has
* been deposited with the U.S. Copyright Office.
*
 -->
<head>
<title><%= getMessage("productTitle", currentLocale) %></title>
<link rel="stylesheet" href="<%=request.getContextPath()%>/dojo/dojo_1.8.1/dojo/resources/dojo.css">
<link rel="stylesheet" href="<%=request.getContextPath()%>/dojo/dojo_1.8.1/dijit/themes/dijit.css">
<link rel="stylesheet" href="<%=request.getContextPath()%>/dojo/dojo_1.8.1/dijit/themes/dijit_rtl.css">
<link rel="stylesheet" href="<%=request.getContextPath()%>/dojo/ibmjs/idx/themes/oneui/idx/widget/commonMessageIcons.css">
<link rel="stylesheet" href="<%=request.getContextPath()%>/dojo/ibmjs/idx/themes/oneui/oneui.css">
<link rel="stylesheet" href="<%=request.getContextPath()%>/images/images.css">
<link rel="stylesheet" href="<%=request.getContextPath()%>/ibmjs/icons/icons.css">

<style type="text/css">
    html, body {
        width: 100%;
        height: 100%;
        margin: 0;
        overflow:hidden;
    }
    
    #loadingDiv {
        background-color: #fff;
        background-image: url('<%=request.getContextPath()%>/dojo/ibmjs/idx/themes/oneui/idx/images/loadingAnimation38px.gif');
        background-repeat: no-repeat;
        background-position: center;
    }
</style>
<script>
var dojoConfig = {
    async: true, 
    locale: "<%=localeStr%>",
    has: {
        "dojo-firebug": true,
        "dojo-debug-messages": true
    },
    packages: [
        {name: "idx", location: "../../ibmjs/idx"},
        {name: "dojo", location: "." },
        {name: "wizard", location: "<%=request.getContextPath()%>/ibmjs/wizard"},
        {name: "admin", location: "<%=request.getContextPath()%>/ibmjs"}
    ]
};
</script>
<script src='<%=request.getContextPath()%>/dojo/dojo_1.8.1/dojo/dojo.js'></script>
<script type="text/javascript">
var connectionStore = null;
// Global varaible.  This will be replace wizardMode from the dsiWizardObject
var pageWizardMode =    "";
var vendorJarFile = "";
var jarList =[""];
var pagePayload = "";
var inBootStrapMode = false;
var bootstrapPayload = "";
var bootstrapNotConfigured = false;

//Context path always empty string in dev.  Use to set environment aware url.
var contextRoot = "<%=request.getContextPath()%>";
var url = "<%=request.getContextPath()%>/rest/datastore/";

var connectionGridSelectedIndex = -1;
var connectionGridSelectedForDelete = -1;
var optimDirItemsToDelete = null;
var rowDataClear = "";
var newConnectionId = "";
var POST_HEADERS = {"Content-Type": "application/json; charset=utf-8"};
var PUT_HEADERS = {"Content-Type": "application/json; charset=utf-8"};
var MISSING_PROPERTIES_STATUS = "Missing Properties";
var CUSTOM_URL ="Custom URL";
var CUSTOM_URL_USED = CUSTOM_URL +" Used"
var ditaCode="";
var supportURL="";
var msgText="";
var msgExplanation="";
var msgUserResponse="";
var msgSystemAction ="";
var editVersion = "";
var editVendor = "";

function idleLogout() {
    var t;
    var timeoutInterval = <%= session.getMaxInactiveInterval() %>;
    if(timeoutInterval <= 0){
        timeoutInterval = 60 * 60;//1 hour
        console.log("Timeout interval for OCM was set to unlimited. Enforcing timeout to be " + timeoutInterval + " seconds");
    }
    console.log("Timeout interval for OCM= " + timeoutInterval + " seconds");
    window.onload = resetTimeout;
    window.onmousemove = resetTimeout;
    window.onmousedown = resetTimeout;
    window.ontouchstart = resetTimeout;
    window.onclick = resetTimeout;
    window.onkeypress = resetTimeout;
    window.addEventListener('scroll', resetTimeout, true);

    function sessionTimedOut() {
        var timeoutInMinutes = timeoutInterval/60;
        console.log("Optim connection manager session has expired after " + timeoutInMinutes + " minutes of inactivity");
        handleLogout();
    }

    function resetTimeout() {
        clearTimeout(t);
        t = setTimeout(sessionTimedOut, (timeoutInterval*1000));
    }
}
idleLogout();
var path = "<%= path %>";
if(typeof(Storage) !== "undefined") {
   sessionStorage.refererURL = path;
}

window.addEventListener('storage', function(event){
    if (event.key === 'logout-event' && event.newValue === 'logout') { 
        localStorage.removeItem('logout-event');
        window.location = contextRoot + "/logout.jsp";
    }
});
    
require([
    "dojo/parser",
    "dojo/on",
    "dijit/registry",
    "dojo/ready",
    "idx/layout/BorderContainer",
    "dijit/layout/ContentPane",
    "idx/layout/ListNavController",
    "idx/widget/Menu",
    "idx/app/Header",
    "dijit/MenuItem",
    "dojox/grid/EnhancedGrid",
    "dojox/grid/enhanced/plugins/Menu",
    "dojo/data/ItemFileWriteStore",
    "dijit/form/Button",
    "idx/form/buttons",
    "dijit/Toolbar",
    "dijit/layout/TabContainer",
    "dijit/layout/StackContainer",
    "dijit/Dialog",
    "idx/dialogs",
    "idx/widget/HoverHelp",
    "idx/widget/ModalDialog",
    "wizard/DsiWizard",
    "wizard/DsiWizardIntroPage",
    "wizard/DsiWizardFirstPage",
    "wizard/DsiWizardSecondPage",
    "wizard/DsiWizardThirdPage",
    "idx/grid/PropertyGrid",
    "dojo/domReady!",
    "admin/users/views/UserRegistry"],
    function(dParser, dom, dRegistry) {     
        dParser.parse(); // parse declarative widgets
        connectionGrid.store == null;
        setButtonsState(false);
        preLoader.loadComplete();
        //_dRegistry = dRegistry;
        var userRegistry = new admin.users.views.UserRegistry({title:"<%= getMessage("usersNavLabel", currentLocale) %>", id:"userRegistry"});
        userRegistry.startup();
        var stackContainer = dRegistry.byId("std_gblMgmtStack");
        stackContainer.addChild(userRegistry);
        warnRecoveryMode();
        alertLastLoginMessage();
    }
);

function loadStartupConnection(){
    getDataStores();
    getProductInformation();
    getStartupMode();
}

//Get the list of data stores, populating the data store grid
//Clean Function
function getDataStores(){
    require(["dojo/dom"], function(dom){
        dom.byId("gridMessageDiv").innerHTML = "";
        dom.byId("gridMessageDiv").style.visibility = "hidden";
    });
    console.log("URL: " + url); 
    var xhrArgs = {
               url: url,
               preventCache: true,
               handleAs: 'json',
               load: handleGetDataStores,
               error: handleGetDataStoresError
       }
    var deferred = dojo.xhrGet(xhrArgs);        
}

function refreshRestCall() {
    var prodInfo = url + "PRODUCTINFO"
    var xhrArgs = {
               url: prodInfo,
               async: false,
               handleAs: 'json',
               load: refreshSuccess,
               error: refreshFailure
       }
    var deferred = dojo.xhrGet(xhrArgs);        
}

function refreshSuccess(data, ioArgs) {
    var buildID = data.buildID
    var version = data.version;
    //do nothing. Rest call was made just to keep the session active.
}

function refreshFailure(error, ioArgs) {
    console.log("Error encountered while refreshing... " + error);
    handleLogout();
}

//Handler function to process the list of data stores
//Clean Function
function handleGetDataStores(data){
    connectionStore = new dojo.data.ItemFileWriteStore({
        clearOnClose:true,
        data: data
    }); 
    connectionGrid.setStore(connectionStore); // refresh DataGrid with new store data
    connectionGrid.on("RowClick", handleOnRowClick);
    connectionStore.fetch({onComplete: fetchComplete});
}

function getProductInformation(){
    var prodInfo = url + "PRODUCTINFO"
    console.log("URL: " + prodInfo); 
    var xhrArgs = {
               url: prodInfo,
               async: false,
               handleAs: 'json',
               handle: handleProdInfo 
       }
    var deferred = dojo.xhrGet(xhrArgs);        
}

function handleProdInfo(data){
    require(["dojo/dom"], function(dom){
        dom.byId("buildIDDiv").innerHTML = data.buildID
        dom.byId("productVersionDiv").innerHTML = data.version;
    });
}

//Get the startup mode
//Clean Function
function getStartupMode(){
    require(["dojo/dom"], function(dom){
        dom.byId("gridMessageDiv").innerHTML = "";
        dom.byId("gridMessageDiv").style.visibility = "hidden";
    });
    var startup = url + "STARTUPMODE"
    console.log("URL: " + startup); 
    var xhrArgs = {
               url: startup,                  
               handleAs: 'json',
               load: handleStartupMode,
               error: handleStartupModeError
       }
    var deferred = dojo.xhrGet(xhrArgs);        
}

//Handler function to remove
//Clean Function
function handleStartupMode(){
    require(["dojo/dom"], function(dom){
        dom.byId("configureOCM").style.visibility = "hidden";
        dom.byId("configureOCM").style.display = "none";
    });
}



function getQueryStringVars()
{
    var vars = [], hash;
    var hashes = window.location.href.slice(window.location.href.indexOf('?') + 1).split('&');
    for(var i = 0; i < hashes.length; i++)
    {
        hash = hashes[i].split('=');
        vars.push(hash[0]);
        vars[hash[0]] = hash[1];
    }
    return vars;
}

//Handler function to show 
//
function handleStartupModeError(error){
     var errMsg = "";
        if(error.status == 406){
            require(["dojo/dom"], function(dom){
                dom.byId("configureOCM").style.visibility = "visible";
                dom.byId("configureOCM").style.display = "";
            });
        }else{
            errMsg = "<%= getMessage("generalErrorMessage", currentLocale) %>";
            require(["dojo/dom"], function(dom){
                dom.byId("errorMessage").innerHTML = errMsg;
            });
            dijit.byId('errorAlert').show();
        }
        console.log(error.xhr.status + " " + error.xhr.statusText);
    
}

//Helper function to force selection of the first row in the data store grid
//Clean Function
function fetchComplete(items) {
    if (items != null && items.length > 0) {
        setButtonsState(true);
        var selectedIndex = 0;
        if (newConnectionId != "") {
            for (var i = 0; i < items.length; i++) {
                if (connectionStore.getValue(items[i], "id") == newConnectionId) {
                    selectedIndex = i;
                }
            } 
        }
        dijit.byId("connectionGrid").selection.setSelected(selectedIndex,true);
        dijit.byId("connectionGrid").scrollToRow(selectedIndex);
        connectionGridSelectedIndex = selectedIndex;
        updateDetails(connectionStore.getValue(items[selectedIndex], "overrideURI"),connectionStore.getValue(items[selectedIndex], "url"),connectionStore.getValue(items[selectedIndex], "schema"));
        require(["dojo/dom"], function(dom){
            dom.byId("infoHeader").innerHTML = "<img src='" + contextRoot + "/images/gridArrow.png'/><%= getMessage("infoHeaderPrefix", currentLocale) %> " + connectionStore.getValue(items[selectedIndex], "name");
        });
        newConnectionId = "";
    }
}

//Helper function to set button state and row detail information when row clicked
//Clean Function
function handleOnRowClick(event) {
    connectionGridSelectedIndex = event.rowIndex;
    setButtonsState(true);
    var rowData = connectionGrid.getItem(connectionGridSelectedIndex);
    if(rowData != null){
        require(["dojo/dom"], function(dom){
            dom.byId("infoHeader").innerHTML = "<img src='" + contextRoot + "/images/gridArrow.png'/><%= getMessage("infoHeaderPrefix", currentLocale) %> " + rowData.name;
        });
        updateDetails(rowData.overrideURI,rowData.url,rowData.schema);
    }
}

function updateDetails(override,url,schema){
    var details = "";
    if (override!=null && override.length > 0){
        details = parseRACURL(override);
    }else{
        details = parseJDBCUrl(url);
    }
    details.schema = schema;
    connectionDetail.set("data", details);
}

//Handler function to process error conditions from the getDataStores() function
//Clean Function
 function handleGetDataStoresError(error){
     var errMsg = "";
        switch(error.status){
            case 404: 
                //Not Found
                errMsg = "<%= getMessage("optimDirConnectionEmptyMessage", currentLocale) %>";
                connectionGrid.setStore(connectionStore);
                if (connectionGrid.getItem(0) == null) {
                    var result = "<table style='border:none'><tr><td style='padding-left:20px'><div class='oneuiMsgInfo16' /></td><td style='padding-left:5px'>" + errMsg + "</td></tr></table>";
                    require(["dojo/dom"], function(dom){
                        dom.byId("gridMessageDiv").innerHTML = result;
                        dom.byId("gridMessageDiv").style.visibility = "visible";
                    });
                } else {
                    window.location = contextRoot + "/admin/main.jsp";
                }
                break;
            case 412: //Display the wizard
                errMsg = "<%= getMessage("optimDirConnectionEmptyMessage", currentLocale) %>";
                console.log(errMsg+":This error indicates that there is not a bootstrpa datastore.Start Wizard.");
                bootstrapNotConfigured = true ;
                handleNewOCM();
                break;
            default:    
                //General Error
                errMsg = "<%= getMessage("generalErrorMessage", currentLocale) %>";
                require(["dojo/dom"], function(dom){
                    dom.byId("errorMessage").innerHTML = errMsg;
                });
                dijit.byId('errorAlert').show();
        }
        console.log(error.xhr.status + " " + error.xhr.statusText);
 }

//Helper function to set main page button states based upon the data store grid state
//Clean Function
function setButtonsState(state){
        dijit.byId("editConnection").set('disabled',!state);
        dijit.byId("removeConnection").set('disabled',!state);
        dijit.byId("testConnection").set('disabled',!state);
    
}

function sessionTimeoutError(){
    require(["dojo/dom"], function(dom){
        dom.byId("sessionTimeoutErrorMessage").innerHTML = "The session has been invalidated. You will need to login again.";
    });
    if(dijit.byId('sessionTimeoutErrorAlert') !== undefined){
        dijit.byId('sessionTimeoutErrorAlert').show();
    }
}

function alertLastLoginMessage(){
    var user = getUserName();
    var lastLoginTime = localStorage.getItem('last-login-time');
    
    require(["dojo/dom", "dojo/string"], function(dom, string){
        var showLastLogin = true;
        if(lastLoginTime !== null && lastLoginTime !== '0'){
            var lastLoginMsg = "<%= lastLoginMessage %>";
            lastLoginMsg = string.substitute(lastLoginMsg, {'userID': user, 'loginTime':lastLoginTime});
            dom.byId("lastLoginAlertMessage").innerHTML = lastLoginMsg;
        } else {
            if(lastLoginTime == null) {
                showLastLogin = false;
            }
            var lastLoginMsgNotAvailable = "<%= lastLoginMessageNotAvailable %>";
            lastLoginMsgNotAvailable = string.substitute(lastLoginMsgNotAvailable, {'userID': user});
            dom.byId("lastLoginAlertMessage").innerHTML = lastLoginMsgNotAvailable;
        }
        localStorage.removeItem('last-login-time');
        if(dijit.byId('lastLoginAlert') !== undefined && showLastLogin){
            dijit.byId('lastLoginAlert').show();
        }
        else {
            loadStartupConnection();
        }
    });
}

function isSessionValid(callback){
    var prodInfo = url + "PRODUCTINFO"
    var xhrArgs = {
               url: prodInfo,
               sync: true,
               handleAs: 'json',
               load: function (data) { callback.apply(null); },
               error: function (error) { sessionTimeoutError(); }
       }
    var deferred = dojo.xhrGet(xhrArgs);
}

//Helper function to return the session user
//Clean Function
function getUserName() {
    var userName = null;
    <%
        String jspUserName = null;
        try{
            jspUserName =request.getUserPrincipal().getName();
        }catch(Exception e){
            //do nothing we are in dev mode
        }
    %>
    userName = "<%=jspUserName%>";
    if (userName == null || userName == "null" || userName =="") {
        userName="admin";
    }
    return userName;
}


//Helper function to refresh the data store grid
//Clean Function
function handleRefresh() {
    setButtonsState(false);
    connectionGridSelectedIndex = -1;
    connectionGrid.selection.clear();
    connectionDetail.set("data", rowDataClear);
    require(["dojo/dom"], function(dom){
        dom.byId("infoHeader").innerHTML = "<%= getMessage("infoHeaderTitle", currentLocale) %>";
    });
    getDataStores();
    getStartupMode();
    if(connectionStore != null){
        connectionGrid.setSortInfo(1);
    }
}

//Launch the New data store wizard

function handleNew() {
    inBootStrapMode = false;
    dsiWizardSecondPage.cannotGoBack = false;
    dsiWizardSecondPage.cannotGoNext = false;
    newDataStoreCommon(dsiWizardFirstPage,"<%= getMessage("newOptimDirectoryConnectionTitle", currentLocale) %>");
}


//Launch new OCM

function handleNewOCM() {
    getStartupDataStore();
    inBootStrapMode = true;
    dsiWizardIntroPage.cannotGoBack = true;
    dsiWizardFirstPage.cannotGoBack = false;
    dsiWizardIntroPage.cannotGoNext = false;
    newDataStoreCommon(dsiWizardIntroPage,"<%= getMessage("newOCMConnectionTitle", currentLocale) %>")
}

// Common elements to a new Optim or OCM Datastore
function newDataStoreCommon(pageToSelect,pageTitle){
    pageWizardMode = "new";
    dsiWizard.set("mode","new");
    dsiWizardSecondPage.setDbFieldsReadOnly(false);
    dsiWizardDialog.set("title", pageTitle);
    dsiWizard.initWizard();
    dsiWizard.selectPage(pageToSelect);
    dsiWizardDialog.show();
}


function cancelNewOCM(){
    handleLogout();
}

function getStartupDataStore(){
    var bootstrapURL = url + "BOOTSTRAP";
    console.log("URL: " + url); 
    var xhrArgs = {
               url: bootstrapURL,
               handleAs: 'json',
               load: handleGetStartupDataStore,
               error: handleGetStartupDataStoreError
       }
    var deferred = dojo.xhrGet(xhrArgs);        
}

function handleGetStartupDataStore(data){
    bootstrapPayload = data;    
}


function  handleGetStartupDataStoreError(error){
     var errMsg = "";
        switch(error.status){
            case 404:
                bootstrapPayload ="";
                //Not Found, do nothing
                //This is acceptab;e
                break;
            default:    
                //General Error
                errMsg = "<%= getMessage("generalErrorMessage", currentLocale) %>";
                require(["dojo/dom"], function(dom){
                    dom.byId("errorMessage").innerHTML = errMsg;
                });
                dijit.byId('errorAlert').show();
        }
        console.log(error.xhr.status + " " + error.xhr.statusText);
}

function warnRecoveryMode(){
    var recover = getQueryStringVars()["recovery"];
    if (recover!=null  && recover =="true"){
        dijit.byId('recoveryModeAlert').show();
    }
}
//Launch the edit data store wizard

function handleEdit() {
    var rowData = connectionGrid.getItem(connectionGridSelectedIndex);
    pageWizardMode = "edit";
    dsiWizardSecondPage.cannotGoBack = false;
    dsiWizardSecondPage.cannotGoNext = false;
    
    dsiWizardDialog.set("title", "<%= getMessage("editOptimDirectoryConnectionTitle", currentLocale) %>");
    dsiWizard.initWizard();
    dsiWizard.selectPage(dsiWizardFirstPage);
    dsiWizardDialog.show(); 
}

//Helper function to process removal of the selected data store from the OCM database
function removeSelectedItems(items, override) { 
    //Delete URL: /datastore/<data store id>
    var deletUrl = ""
    if (override){
        deleteUrl = url + items[0].id +"/"+override; // Force deletion
    }else{
        deleteUrl = url + items[0].id;
    }
    console.log("URL: " + deleteUrl);
    var xhrArgs = {
            url: deleteUrl,
            handleAs: 'json',   
            async: false,
            load: handleUIDeleteDataStores,
            error: handleError
    }
    //Call delete on the server and UI if successful
    var deferred = dojo.xhrDelete(xhrArgs); 
}

    
//Handler to process the return from the data store delete.  
//Updates the action button states and refreshes the data store grid

function handleUIDeleteDataStores(data, ioargs){
    //Call delete from the UI
    var selectedItem = connectionGrid.getItem(connectionGridSelectedIndex); 
    if(selectedItem !== null){
        connectionStore.deleteItem(selectedItem);
        connectionDetail.set("data", rowDataClear);
    }
    require(["dojo/dom"], function(dom){
        dom.byId("infoHeader").innerHTML = "<%= getMessage("infoHeaderTitle", currentLocale) %>";
    });     
    setButtonsState(false);
    handleRefresh();
}

//Tests the connection before deletion
function handleTestBeforeDelete() {
     var rowData = connectionGrid.getItem(connectionGridSelectedIndex); 
     var deleteConnURL = url + "READYTODELETE/" + rowData.id;
     console.log("URL: " + deleteConnURL); 
     var xhrArgs = {
           url: deleteConnURL,            
           handleAs: 'json',
           load: deleteCheck,
           error: handleDeleteCheckError
    }   
     dijit.byId('testConnectionProcessing').show();
     var deferred = dojo.xhrGet(xhrArgs);
}

// Dialog for a an online Optim Directory
function deleteCheck(data){
    dijit.byId('testConnectionProcessing').hide();
    var message = "<%= getMessage("multiDeleteMessage", currentLocale) %>"; 
    var override = false;
    var items = connectionGrid.selection.getSelected();
    connectionGridSelectedForDelete = connectionGrid.selection.selectedIndex;
    if (data.online !=  true){
        message =   "<B>Important:</B><BR/><%= getMessage("singleDeleteConfirmPrefix1", currentLocale) %> " + items[0].name +". <%= getMessage("singleDeleteConfirmMiddle1", currentLocale) %> "  +  items[0].name + ". <BR/><B><%= getMessage("singleDeleteConfirmSuffix1", currentLocale) %></B> ";
        override = true;
    }else if (data.securityEnabled == true){
        message = "<B>Important:</B><BR/><%= getMessage("singleDeleteConfirmPrefix2", currentLocale) %> " + items[0].name +". <%= getMessage("singleDeleteConfirmMiddle2", currentLocale) %> "  +  items[0].name + ". <BR/><B><%= getMessage("singleDeleteConfirmSuffix2", currentLocale) %></B> "
        override=true;
    }
    if (items.length){
        var deleteDialog = idx.confirm({
                                    id: "deleteDialog",
                                    text: message,
                                    buttonLabel:"Remove",
                                    cancelButtonLabel: "Don't Remove",
                                    title: "<%= getMessage("deleteConfirmationTitle", currentLocale) %>"},
                                    function(){ removeSelectedItems(items, override); }, 
                                    function(){ return; },
                                    "deleteDialog");
    }   
}

//Something wholly unexpected happend on the server.
function handleDeleteCheckError(response,data){
    dijit.byId('testConnectionProcessing').hide();
    errMsg = "<%= getMessage("generalErrorMessage", currentLocale) %>";
    require(["dojo/dom"], function(dom){
    dom.byId("errorMessage").innerHTML = errMsg;
    });
    dijit.byId('errorAlert').show();
}

//Tests the connectivity of the selected data store

function handleTestConnection() {
     var rowData = connectionGrid.getItem(connectionGridSelectedIndex); 
     var testConnURL = url + "TEST/" + rowData.id;
     console.log("URL: " + testConnURL); 
     var xhrArgs = {
            url: testConnURL,   
            async: false,
            handleAs: 'json',
            headers: POST_HEADERS,
            load: handleTestConnResult,
            error: handleTestConnError
     }  
     dijit.byId('testConnectionProcessing').show();
     
     var deferred = dojo.xhrPost(xhrArgs);
}

//Handler function to process results from the test of data store connectivity

function handleTestConnResult(data){
    dijit.byId('testConnectionProcessing').hide();
    dijit.byId('testSuccessAlert').show();
}

//Handler function to process error results from the test of data store connectivity

function handleTestConnError(){
    dijit.byId('testConnectionProcessing').hide();
    dijit.byId('testFailureAlert').show();
}

//Handling of any errors from the backend
function handleDitaError(response,data){
    dijit.byId('testConnectionProcessing').hide();
    var ditaMessage = JSON.parse(data.error.xhr.response);
    handleDitaMsg(ditaMessage);
}
//Retrieves the error information from payload to display showDita Dialog
function handleDitaMsg(ditaMessage){
    setDitaCode(ditaMessage.prefix + ditaMessage.id);
    setMsgText(ditaMessage.message);
    setMsgExplanation(ditaMessage.explanation);
    setMsgUserResponse(ditaMessage.userResponse);
    setMsgSystemAction(ditaMessage.systemAction);
    setSupportURL("http://www.ibm.com/support");    
    showDitaError();
}

//Dita message Dialog
function showDitaError(){
    var errorDialog = dijit.byId("errorDialog");
    if(!errorDialog){
        errorDialog = new idx.widget.ModalDialog({
            id: "errorDialog",
            type: "error", 
            text: getMsgText(),
            info: [{
                title: "Error Information",
                content: getMsgExplanation()
            },{
                title: "Details",
                content: getMsgText() + "<br/><br/>Explanation:<br/>" + getMsgExplanation() + "<br/><br/>" +
                "System Action:<br/>" + getMsgSystemAction() + "<br/><br/>User Response:<br/>"+ getMsgUserResponse()
            }],
            messageId: getDitaCode(),
            messageRef: getSupportURL(),
            messageTimeStamp: new Date()
            
        });
    }else{
        errorDialog.messageId = getDitaCode();
        errorDialog.messageRef = getSupportURL();
        errorDialog.text = getMsgText();
        errorDialog.messageTimeStamp = new Date();
        errorDialog.info = [{
            title: "Error Information",
            content: getDitaCode()+ ":" + getMsgExplanation()
        },{
            title: "Details",
            content:getMsgText() + "<br/><br/>Explanation:<br/>" + getMsgExplanation() + "<br/><br/>" +
            "System Action:<br/>" + getMsgSystemAction() + "<br/><br/>User Response:<br/>"+ getMsgUserResponse()
        }];
    }
    errorDialog.show();
}


//Handler function to process results from the test of data store connectivity
function handleOCMConfigureResult(data){
    dijit.byId('ocmConfigProcessing').hide();
    dijit.byId('ocmSuccessAlert').show();
    bootstrapNotConfigured = false;
}

//Handler function to process error results from the test of data store connectivity

function handleOCMConfigureError(response, data){
    dijit.byId('ocmConfigProcessing').hide();
    if (response.status==500){
        handleDitaError(response,data);
    }else{
        dijit.byId('ocmFailureAlert').show();   
    }
}


//Generic error handling method for all general purpose AJAX calls to the server

function handleError(response, data){
        dijit.byId('directoryConfigProcessing').hide();
        var errMsg = "";
        if (response.status ==500){
            handleDitaError(response,data);
        }else{
            switch(response.status){
                case 404: 
                    //Not Found
                    errMsg = "<%= getMessage("optimDirNotFound", currentLocale) %>";
                    break;
                case 409:
                    //Duplicate
                    errMsg = "<%= getMessage("optimDirConflict", currentLocale) %>";
                    break;
                default:    
                    //General Error
                    errMsg = "<%= getMessage("generalErrorMessage", currentLocale) %>";
            }
            require(["dojo/dom"], function(dom){
                dom.byId("errorMessage").innerHTML = errMsg;
            });
            dijit.byId('errorAlert').show();
            console.log(response.xhr.status+" "+ response.xhr.statusText);
        }

    }   

//Helper function to remove current panel when cancel button clicked

function handleDialogCanceled() {
    if (bootstrapNotConfigured){
        handleLogout();
    }else{
        if (inBootStrapMode){
            handleOCMConfigDialogClosed(true);
        }
    //  handleNewConnectionState();
    }
    
}


//Function to address a failed attempt to make a connection.

function failedTableCreation(){
    handleNewConnectionState();
}

//Manages the newConnection state

function handleNewConnectionState() {
    if (bootstrapNotConfigured){
        dijit.byId("newConnection").set('disabled',true);
    }else{
        dijit.byId("newConnection").set('disabled',false);
    }
}


function handleOCMConfigDialogClosed(bool){
        inBootStrapMode = false;
        bootstrapNotConfigured = !bool;
        handleRefresh();
        handleNewConnectionState();
        
}


//Adds the new data store to the database, or updates an existing data store on edit operation
//Clean Function
function handleDialogExecuted() {
    if (inBootStrapMode == true){
        console.log("URL: " + url); 
        var bootstrapURL = url+"BOOTSTRAP";
        var xhrArgs = {
                    url: bootstrapURL,            
                    postData: dojo.toJson(pagePayload),  
                    handleAs: 'json',
                    headers: POST_HEADERS,
                    load: handleOCMConfigureResult,
                    error: handleOCMConfigureError
            }
        dijit.byId('ocmConfigProcessing').show();
        var deferred = dojo.xhrPost(xhrArgs);
    }else{
        if(pageWizardMode == "new"){
            console.log("URL: " + url); 
            var xhrArgs = {
                        url: url,             
                        postData: dojo.toJson(pagePayload),  
                        handleAs: 'json',
                        headers: POST_HEADERS,
                        load: handleNewDatastore,
                        error: handleError
                }
            dijit.byId('directoryConfigProcessing').show();
            var deferred = dojo.xhrPost(xhrArgs);
        }else if(pageWizardMode == "edit"){
            var rowData = connectionGrid.getItem(connectionGridSelectedIndex);  
            var editUrl = url + rowData.id;
            console.log("URL: " + editUrl); 
            var xhrArgs = {
                        url: editUrl,             
                        putData: dojo.toJson(pagePayload),   
                        handleAs: 'json',
                        headers: PUT_HEADERS,
                        load: handleEditDatastore,
                        error: handleError
                }
            dijit.byId('directoryConfigProcessing').show();
            var deferred = dojo.xhrPut(xhrArgs);        
        }
    }
}

//Helper function to refresh the data store grid when a new data store is added
//Clean Function
function handleNewDatastore(data, ioargs){
    dijit.byId('directoryConfigProcessing').hide();
    var loc = ioargs.xhr.getResponseHeader("Location");
    newConnectionId = loc.substring(loc.lastIndexOf("/") + 1, loc.length);
    console.log("location:" + loc);
    console.log("connection id:" + newConnectionId);
    handleRefresh();
}

//Helper function to refresh the data store grid when a data store is edited

function handleEditDatastore(data){
    dijit.byId('directoryConfigProcessing').hide();
    handleRefresh();
}

function handleLogout() {
    //This will trigger a event if ocm/manager are both logged in. And one application logout should logout the other one as well
    localStorage.setItem('logout-event', 'logout');
    
    //clear the items we set in localStorage
    localStorage.removeItem('logout-event');

    var xhrArgs = {
            url: "<%=request.getContextPath()%>/ibm_security_logout",  
            handleAs: 'text',
            load: function(data){window.location = contextRoot + "/logout.jsp";},
            error: function(error){window.location = contextRoot + "/logout.jsp";}
    }
    dojo.xhrPost(xhrArgs);
}

function handleIBMSupport() {
    var win=window.open("http://www.ibm.com/support", '_blank');
    win.focus();
    //window.location = "http://www.ibm.com/support";
}

function handleHelp() {
    var win=window.open("http://www.ibm.com/support/knowledgecenter/SSMLQ4_11.3.0/com.ibm.nex.install.doc/topics/opinstall_configuring_connection_manager.html", '_blank');
    win.focus();
    
}

function handleAbout() {
    dijit.byId('aboutDialog').show();
}

function formatConnectionStatus(connectionStatus) {
    var displayStatus;
    if (connectionStatus == "Complete") {
        displayStatus = "<img src='" + contextRoot + "/images/status_complete.png'/>";
        connectionStatus = "<%= getMessage("completeMessage", currentLocale) %>";
    } else {
        displayStatus = "<img src='" + contextRoot + "/images/status_missing_properties.png'/>";
        connectionStatus = "<%= getMessage("missingPropMessage", currentLocale) %>";
    }
    displayStatus += connectionStatus;
    return displayStatus;
}


function formatDescription(description) {
    if (description == null) {
        description = "<%= getMessage("notAvailableMessage", currentLocale) %>";            
    }
    return description;
}

function parseRACURL(racURL){
    var details = { host: CUSTOM_URL_USED,
            port: CUSTOM_URL_USED,
            database: CUSTOM_URL_USED,
            url: racURL
          };
    return details;
}

function parseJDBCUrl(jdbcUrl) {
    var details = { host: "<%= getMessage("notAvailableMessage", currentLocale) %>",
                    port: "<%= getMessage("notAvailableMessage", currentLocale) %>",
                    database: "<%= getMessage("notAvailableMessage", currentLocale) %>",
                    url: "<%= getMessage("notAvailableMessage", currentLocale) %>"
                  };
    if (jdbcUrl != null) {
        var component = jdbcUrl.toString().split(":");
        switch(component[1]){
            case "oracle":
                if(component[4].indexOf("/") != -1) {
                	var portAndDB = component[4].split("/");
                    details = { host: component[3].substring(1), port: portAndDB[0], database: portAndDB[1], url: jdbcUrl.toString() };
                }
                else {
                    details = { host: component[3].substring(1), port: component[4], database: component[5], url: jdbcUrl.toString() };
                }
                break;
            case "db2":
                var portAndDB = component[3].split("/");
                details = { host: component[2].substring(2), port:  portAndDB[0], database: portAndDB[1], url: jdbcUrl.toString() };
                break;
            case "sqlserver":
                var portAndDB = component[3].split(";databaseName=");
                details = { host: component[2].substring(2), port:  portAndDB[0], database: portAndDB[1], url: jdbcUrl.toString() };
                break;
            default:    
        }   
    }
    return details;
}
//Helper functions to proces Dita messages
function getDitaCode(){
    return ditaCode;
}
function getSupportURL(){
    return supportURL;
}
function getMsgText(){
    return msgText;
}
function getMsgExplanation(){
    return msgExplanation;
}
function getMsgUserResponse(){
    return msgUserResponse;
}
function getMsgSystemAction(){
    return msgSystemAction;
}
function setDitaCode(val){
    ditaCode = val;
}
function setSupportURL(val){
    supportURL = val;
}
function setMsgText(val){
    msgText = val;
}
function setMsgExplanation(val){
    msgExplanation = val;
}
function setMsgUserResponse(val){
    msgUserResponse = val;
}
function setMsgSystemAction(val){
    msgSystemAction = val;
}
</script>
    
</head>
<body class="oneui">
    <div id="loadingDiv" class="pageOverlay"></div>
    <script>
        var preLoader;
        require(["dojo/_base/declare", 
                 "dojo/_base/fx", 
                 "dojo/dom", 
                 "dojo/dom-style"],
        function(declare, fx, dom, domStyle){
            var PreLoader = declare(null, {
                loadingNode: null,
                constructor: function(){
                    this.loadingNode = dom.byId('loadingDiv');
                },
                loadComplete: function(){
                    fx.fadeOut({
                        node: this.loadingNode,
                        onEnd: function(node){
                            domStyle.set(node, 'display', 'none');
                        }
                    }).play();
                }
            });
            preLoader = new PreLoader();
        });
    </script>
    <div data-dojo-id="dsiWizardDialog" data-dojo-type="dijit/Dialog" 
        data-dojo-props='title:"Optim Connection Manager Wizard",
                         onExecute:function(){handleDialogExecuted();},
                         onCancel:function(){handleDialogCanceled();}' style="overflow:auto;">
        <div data-dojo-id="dsiWizard" data-dojo-type="wizard.DsiWizard" style="width:100%; height:100%;">
            <div data-dojo-id="dsiWizardIntroPage" data-dojo-type="wizard.DsiWizardIntroPage"></div>
            <div data-dojo-id="dsiWizardFirstPage" data-dojo-type="wizard.DsiWizardFirstPage"></div>
            <div data-dojo-id="dsiWizardSecondPage" data-dojo-type="wizard.DsiWizardSecondPage"></div>
            <div data-dojo-id="dsiWizardThirdPage" data-dojo-type="wizard.DsiWizardThirdPage"></div>
        </div>
    </div>
    <div id="borderContainer" data-dojo-type="idx/layout/BorderContainer" data-dojo-props="design:'headline', gutters:false" style="width:100%; height:100%">
        <div id="topPane" data-dojo-type="dijit/layout/ContentPane" data-dojo-props="region:'top'" >
            <div data-dojo-type="idx.widget.Menu" id="helpmenu" style="display: none;">
                <div data-dojo-type="dijit.MenuItem" onclick="handleHelp"><%= getMessage("helpLabel", currentLocale) %></div>
                <div data-dojo-type="dijit.MenuItem" onclick="handleIBMSupport"><%= getMessage("IBMSupportLabel", currentLocale) %></div>
                <div data-dojo-type="dijit.MenuItem" onclick="handleAbout"><%= getMessage("aboutLabel", currentLocale) %></div>
            </div>  
            <div data-dojo-type="idx.widget.Menu" id="usermenu" style="display: none;">
                <div id="configureOCM" data-dojo-type="dijit.MenuItem" onclick="isSessionValid(handleNewOCM)" style ="visibility:hidden"><%= getMessage("ocmConfigLabel", currentLocale) %></div>
                <div data-dojo-type="dijit.MenuItem" onclick="handleLogout"><%= getMessage("logoutLabel", currentLocale) %></div>
            </div>  
            <div id="header" data-dojo-type="idx.app.Header" data-dojo-props="
                primaryTitle: &quot;<%= getMessage("productTitle", currentLocale) %>&quot;,
                user: {displayName: getUserName(), actions: 'usermenu'},
                help: 'helpmenu',
                primaryBannerType: 'thin'">
            </div>
        </div>
        <div id="leftPane" data-dojo-type="dijit/layout/ContentPane"
            data-dojo-props="region:'left',splitter:true"
            class="idxListNavigation" style="width: 100px;" contentFocus="false">
            <span data-dojo-type="idx/layout/ListNavController"
                containerid="std_gblMgmtStack" style="bottom: 0;"> </span>
        </div>
        <div data-dojo-type="dijit.layout.ContentPane" title="Selected Item" region="center">
            <div data-dojo-type="dijit.layout.StackContainer" id="std_gblMgmtStack" data-dojo-props="region:'center'">
                <div id="directoriesPane" data-dojo-type="dijit/layout/ContentPane" data-dojo-props="region:'center'"  title= "<%= getMessage("directoriesLabel", currentLocale) %>">
                        <div id="directoriesBorder" data-dojo-type="idx/layout/BorderContainer" data-dojo-props="design:'headline',gutters:false,liveSplitters:true" >
                            <div id="directorisTopPane" data-dojo-type="dijit/layout/ContentPane" data-dojo-props="region:'top'">
                                <table style="width: 100%;">
                                    <tr>
                                        <td style="padding-left:23px;"><%= getMessage("mainPageSummary", currentLocale) %></td>
                                    </tr>
                                </table>
                            </div>
                            <div id="centerPane" data-dojo-type="dijit/layout/ContentPane" data-dojo-props="region:'center', splitter:true"  style="width:100%; height:100%">
                                <div data-dojo-type="idx.widget.Menu" id="actionMenu" style="display: none;">
                                    <div data-dojo-type="dijit.MenuItem" onClick="isSessionValid(handleEdit)"><%= getMessage("editButtonLabel", currentLocale) %></div>
                                    <div data-dojo-type="dijit.MenuItem" onClick="isSessionValid(handleTestBeforeDelete)"><%= getMessage("removeButtonLabel", currentLocale) %></div>
                                    <div data-dojo-type="dijit.MenuItem" onClick="isSessionValid(handleTestConnection)"><%= getMessage("testConnectionLabel", currentLocale) %></div>
                                </div>
                                <table style="width:100%; border:none; border-collapse:collapse;">
                                    <tr>
                                        <td style="padding-left:23px;">
                                            <div dojoType="dijit.Toolbar">
                                                <div id="newConnection" data-dojo-type="dijit/form/Button" onClick="isSessionValid(handleNew)" data-dojo-props="showLabel:true, iconClass:'newIcon'"><%= getMessage("newButtonLabel", currentLocale) %></div>
                                                <div id="editConnection" data-dojo-type="dijit/form/Button" onClick="isSessionValid(handleEdit)" data-dojo-props="showLabel:true, iconClass:'editIcon'"><%= getMessage("editButtonLabel", currentLocale) %></div>
                                                <div id="removeConnection" data-dojo-type="dijit/form/Button" onClick="isSessionValid(handleTestBeforeDelete)" data-dojo-props="showLabel:true, iconClass:'removeIcon'"><%= getMessage("removeButtonLabel", currentLocale) %></div>
                                                <div id="testConnection" data-dojo-type="dijit/form/Button" onClick="isSessionValid(handleTestConnection)" data-dojo-props="showLabel:true, iconClass:'testIcon'"><%= getMessage("testConnectionLabel", currentLocale) %></div>
                                                <div id="refreshList" data-dojo-type="dijit/form/Button" onClick="isSessionValid(handleRefresh)" data-dojo-props="showLabel:true, iconClass:'refreshIcon'" style="float:right;"><%= getMessage("refreshButtonLabel", currentLocale) %></div>
                                            </div>
                                        </td>
                                    </tr>
                                </table>
                                <table id="connectionGrid"
                                       dojoType="dojox.grid.EnhancedGrid" 
                                       jsid="connectionGrid"
                                       autoHeight="true"
                                       keepSelection="true" 
                                       style="width:100%; border:none;"
                                       store="connectionStore"
                                       query="{ name: '*' }" 
                                       rowsPerPage="20" 
                                       rowselector="true" 
                                       selectionMode="single" 
                                       sortInfo="1" 
                                       plugins="{menus:{selectedRegionMenu:'actionMenu'}}"
                                       loadingMessage="<%= getMessage("mainGridLoadingMessage", currentLocale) %>"
                                       errorMessage="">
                                    <thead>
                                        <tr>
                                            <th field="name" width="20%"><%= getMessage("optimDirLabel", currentLocale) %></th>
                                            <th field="status" width="12%" formatter="formatConnectionStatus"><%= getMessage("connectionStatusLabel", currentLocale) %></th>
                                            <th field="description" width="53%" formatter="formatDescription"><%= getMessage("descriptionLabel", currentLocale) %></th>
                                            <th field="vendor" width="10%"><%= getMessage("vendorLabel", currentLocale) %></th>
                                            <th field="version" width="5%"><%= getMessage("versionLabel", currentLocale) %></th>
                                        </tr>
                                    </thead>
                                </table>
                                <table style="width:100%">
                                    <tr>
                                        <td align="center">
                                            <div id="gridMessageDiv" style="visibility:hidden; width:45em;"></div>      
                                        </td>
                                    </tr>
                                </table>
                            </div>
                            <div id="bottomPane" data-dojo-type="dijit/layout/ContentPane" data-dojo-props="region:'bottom', splitter:true" style="height: 50%">
                                <div data-dojo-type="idx/layout/BorderContainer" data-dojo-props="gutters:false" style="width:100%; height:100%">
                                    <div data-dojo-type="dijit/layout/ContentPane" data-dojo-props="region:'center'">
                                        <h2 id="infoHeader"><%= getMessage("infoHeaderTitle", currentLocale) %></h2>
                                        <hr width="100%" size="2"/>
                                        <div dojoType="idx.grid.PropertyGrid" jsid="connectionDetail" id="connectionDetail"
                                             data="{host: '', port: '', database: '',schema:'', url: ''}"
                                             properties="host, port, database, schema, url"
                                             labelKeySuffix="Label"
                                             resources="{hostLabel: '<%= getMessage("hostLabel", currentLocale) %>', 
                                                         portLabel: '<%= getMessage("portLabel", currentLocale) %>', 
                                                         databaseLabel: '<%= getMessage("databaseLabel", currentLocale) %>',
                                                         schema: '<%= getMessage("schemaLabel", currentLocale) %>',
                                                         urlLabel: '<%= getMessage("urlLabel", currentLocale) %>'}">
                                        </div>
                                    </div>
                                    <div dojoType="dijit.layout.ContentPane" style="width: 10px;" region="leading"></div>
                                    <div dojoType="dijit.layout.ContentPane" style="width: 10px;" region="trailing"></div>
                                </div>
                            </div>
                    </div>
                </div>
            </div>
        </div>
        <div dojoType="dijit.layout.ContentPane" style="width: 10px;" region="trailing"></div>
</div>
    <div id="testSuccessAlert" dojoType="dijit.Dialog" title="<%= getMessage("testConnectionLabel", currentLocale) %>" style="display:none;">
        <div class="dijitDialogPaneContentArea" style="width: 350px; height: 90px; overflow: auto;">
            <table>
                <tr>
                    <td><div class="idxDialogIconInformation" /></td>
                    <td><span class='idxDialogIconText'><%= getMessage("connectionSuccessfulMessage", currentLocale) %></span></td>
                </tr>
            </table>        
        </div>          
        <div class="dijitDialogPaneActionBar">
            <button dojoType="dijit.form.Button" type="submit" label="<%= getMessage("closeButtonLabel", currentLocale) %>" ></button>
        </div>
    </div>
    <div id="testFailureAlert" dojoType="dijit.Dialog" title="<%= getMessage("testConnectionLabel", currentLocale) %>" style="display:none;">
        <div class="dijitDialogPaneContentArea" style="width: 350px; height: 90px; overflow: auto;">
            <table>
                <tr>
                    <td><div class="idxDialogIconError" /></td>
                    <td><span class='idxDialogIconText'><%= getMessage("connectionFailedMessage", currentLocale) %></span></td>
                </tr>
            </table>        
        </div>          
        <div class="dijitDialogPaneActionBar">
            <button dojoType="dijit.form.Button" type="submit" label="<%= getMessage("closeButtonLabel", currentLocale) %>" ></button>  
        </div>
    </div>
    <div id="recoveryModeAlert" dojoType="dijit.Dialog" title="<%= getMessage("recoveryModeLabel", currentLocale) %>" style="display:none;">
        <div class="dijitDialogPaneContentArea" style="width: 350px; height: 90px; overflow: auto;">
            <table>
                <tr>
                    <td><div class="idxDialogIconWarning" /></td>
                    <td><span class='idxDialogIconText'><%= getMessage("recoveryModeMessage", currentLocale) %></span></td>
                </tr>
            </table>        
        </div>          
        <div class="dijitDialogPaneActionBar">
            <button dojoType="dijit.form.Button" type="submit" label="<%= getMessage("recoveryButtonLabel", currentLocale) %>" ></button>   
        </div>
    </div>
    <div id="ocmSuccessAlert" dojoType="dijit.Dialog" title="<%= getMessage("ocmConfigLabel", currentLocale) %>" style="display:none;">
        <div class="dijitDialogPaneContentArea" style="width: 350px; height: 90px; overflow: auto;">
            <table>
                <tr>
                    <td><div class="idxDialogIconInformation" /></td>
                    <td><span class='idxDialogIconText'><%= getMessage("ocmConfigureSuccessfulMessage", currentLocale) %></span></td>
                </tr>
            </table>        
        </div>          
        <div class="dijitDialogPaneActionBar">
            <button dojoType="dijit.form.Button" type="submit" label="<%= getMessage("closeButtonLabel", currentLocale) %>" onclick="handleOCMConfigDialogClosed(true);"></button>
        </div>
    </div>
    <div id="ocmFailureAlert" dojoType="dijit.Dialog" title="<%= getMessage("ocmConfigLabel", currentLocale) %>" style="display:none;">
        <div class="dijitDialogPaneContentArea" style="width: 350px; height: 90px; overflow: auto;">
            <table>
                <tr>
                    <td><div class="idxDialogIconError" /></td>
                    <td><span class='idxDialogIconText'><%= getMessage("ocmConfigureFailedMessage", currentLocale) %></span></td>
                </tr>
            </table>        
        </div>          
        <div class="dijitDialogPaneActionBar">
            <button dojoType="dijit.form.Button" type="submit" label="<%= getMessage("closeButtonLabel", currentLocale) %>" onclick="handleOCMConfigDialogClosed(false);""></button>    
        </div>
    </div>
    <div id="aboutDialog" dojoType="dijit.Dialog" title="<%= getMessage("aboutLabel", currentLocale) + ' ' + getMessage("productTitle", currentLocale)  %>" style="display:none;">
        <div class="dijitDialogPaneContentArea" style="width: 420px; height: 200px; overflow: auto;">
            <table>
                <tr>
                    <td><div class="aboutOCM" /></td>
                    <td style='padding-left:5px; vertical-align:top;'>
                        <span class='idxDialogIconText'>
                            <p><%= getMessage("productTitle", currentLocale) %></p>
                            <p>
                                <%= getMessage("versionLabel", currentLocale) + ": <span id='productVersionDiv'></span>" %>
                                 <br/>Build ID: <span id='buildIDDiv'></span>
                            </p>
                            <p><%= getMessage("copyright", currentLocale) %></p>
                        </span>
                    </td>
                </tr>
            </table>        
        </div>
        <div class="dijitDialogPaneActionBar">
            <button dojoType="dijit.form.Button" type="submit" label="<%= getMessage("closeButtonLabel", currentLocale) %>" ></button>  
        </div>
    </div>
    <div id="errorAlert" dojoType="dijit.Dialog" title="<%= getMessage("errorEncounteredLabel", currentLocale) %>" style="display:none;">
        <div class="dijitDialogPaneContentArea" style="width: 350px; height: 90px; overflow: auto;">
            <table>
                <tr>
                    <td><div class="idxDialogIconError" /></td>
                    <td><span class='idxDialogIconText' id="errorMessage"><%= getMessage("errorEncounteredMessage", currentLocale) %></span></td>
                </tr>
            </table>        
        </div>          
        <div class="dijitDialogPaneActionBar">
            <button dojoType="dijit.form.Button" type="submit" label="<%= getMessage("okButtonLabel", currentLocale) %>" ></button> 
        </div>
    </div>
   <div id="sessionTimeoutErrorAlert" dojoType="dijit.Dialog" title="<%= getMessage("errorEncounteredLabel", currentLocale) %>" style="display:none;">
       <div class="dijitDialogPaneContentArea" style="width: 350px; height: 90px; overflow: auto;">
           <table>
               <tr>
                   <td><div class="idxDialogIconError" /></td>
                   <td><span class='idxDialogIconText' id="sessionTimeoutErrorMessage"><%= getMessage("errorEncounteredMessage", currentLocale) %></span></td>
               </tr>
           </table>        
       </div>          
       <div class="dijitDialogPaneActionBar">
           <button dojoType="dijit.form.Button" type="submit" label="<%= getMessage("okButtonLabel", currentLocale)%>"  onClick="handleLogout();"></button> 
       </div>
    </div>
    <div id="lastLoginAlert" dojoType="dijit.Dialog" title="<%= getMessage("lastLoginTitle", new Locale("en", "US"))%>" style="display:none;">
       <div class="dijitDialogPaneContentArea" style="width: 350px; height: 90px; overflow: auto;">
           <table>
               <tr>
                   <td><div class="idxDialogIconInformation" /></td>
                   <td><span class='idxDialogIconText' id="lastLoginAlertMessage">Last Login time</span></td>
               </tr>
           </table>        
       </div>          
       <div class="dijitDialogPaneActionBar">
           <button dojoType="dijit.form.Button" type="submit" label="<%= getMessage("okButtonLabel", currentLocale)%> " onclick="loadStartupConnection();"></button> 
       </div>
    </div>
    <div id="testConnectionProcessing" jsId="testConnectionProcessing" dojoType="dijit.Dialog" title="<%= getMessage("testConnectionProgressTitle", currentLocale) %>" style="display:none;">
        <div class="dijitDialogPaneContentArea" style="width: 350px; height: 90px; overflow: hidden;">
            <div class="idxSignIcon dijitContentPaneLoading" style="width: 100%; height: 100%;"><%= getMessage("testConnectionProgressMessage", currentLocale) %></div>  
        </div>
        <div class="dijitDialogPaneActionBar">
            <button dojoType="dijit.form.Button" type="button" label="<%= getMessage("cancelButtonLabel", currentLocale) %>" onClick="testConnectionProcessing.hide();"></button>       
        </div>          
    </div>
    <div id="schemaSearchProcessing" jsId="schemaSearchProcessing" dojoType="dijit.Dialog" title="<%= getMessage("schemaSearchProgressTitle", currentLocale) %>" style="display:none;">
        <div class="dijitDialogPaneContentArea" style="width: 350px; height: 90px; overflow: hidden;">
            <div class="idxSignIcon dijitContentPaneLoading" style="width: 100%; height: 100%;"><%= getMessage("schemaSearchProgressMessage", currentLocale) %></div>  
        </div>
        <div class="dijitDialogPaneActionBar">
            <button dojoType="dijit.form.Button" type="button" label="<%= getMessage("cancelButtonLabel", currentLocale) %>" onClick="schemaSearchProcessing.hide();"></button>         
        </div>          
    </div>
    <div id="ocmConfigProcessing" jsId="ocmConfigProcessing" dojoType="dijit.Dialog" title="<%= getMessage("ocmConfigProgressTitle", currentLocale) %>" style="display:none;">
        <div class="dijitDialogPaneContentArea" style="width: 350px; height: 90px; overflow: hidden;">
            <div class="idxSignIcon dijitContentPaneLoading" style="width: 100%; height: 100%;"><%= getMessage("ocmConfigProgressMessage", currentLocale) %></div>  
        </div>
        <div class="dijitDialogPaneActionBar">
            <button dojoType="dijit.form.Button" type="button" label="<%= getMessage("cancelButtonLabel", currentLocale) %>" onClick="ocmConfigProcessing.hide();"></button>        
        </div>          
    </div>
    <div id="directoryConfigProcessing" jsId="ocmConfigProcessing" dojoType="dijit.Dialog" title="<%= getMessage("directoryConfigProgressTitle", currentLocale) %>" style="display:none;">
        <div class="dijitDialogPaneContentArea" style="width: 350px; height: 90px; overflow: hidden;">
            <div class="idxSignIcon dijitContentPaneLoading" style="width: 100%; height: 100%;"><%= getMessage("directoryConfigProgressMessage", currentLocale) %></div>  
        </div>
        <div class="dijitDialogPaneActionBar">
            <button dojoType="dijit.form.Button" type="button" label="<%= getMessage("cancelButtonLabel", currentLocale) %>" onClick="ocmConfigProcessing.hide();"></button>        
        </div>          
    </div>      
    <div id="checkOptimDirProcessing" jsId="checkOptimDirProcessing" dojoType="dijit.Dialog" title="<%= getMessage("optimDirSearchProgressTitle", currentLocale) %>" style="display:none;">
        <div class="dijitDialogPaneContentArea" style="width: 350px; height: 90px; overflow: hidden;">
            <div class="idxSignIcon dijitContentPaneLoading" style="width: 100%; height: 100%;"><%= getMessage("optimDirSearchProgressMessage", currentLocale) %></div>  
        </div>
        <div class="dijitDialogPaneActionBar">
            <button dojoType="dijit.form.Button" type="button" label="<%= getMessage("cancelButtonLabel", currentLocale) %>" onClick="checkOptimDirProcessing.hide();"></button>        
        </div>          
    </div>
    <div id="jarUploadProcessing" jsId="jarUploadProcessing" dojoType="dijit.Dialog" title="<%= getMessage("jarUploadProgressTitle", currentLocale) %>" style="display:none;">
        <div class="dijitDialogPaneContentArea" style="width: 350px; height: 90px; overflow: hidden;">
            <div class="idxSignIcon dijitContentPaneLoading" style="width: 100%; height: 100%;"><%= getMessage("jarUploadProgressMessage", currentLocale) %></div>  
        </div>
        <div class="dijitDialogPaneActionBar">
            <button dojoType="dijit.form.Button" type="button" label="<%= getMessage("cancelButtonLabel", currentLocale) %>" onClick="jarUploadProcessing.hide();"></button>        
        </div>      
    </div>
</body>

</html>